From 540b1ec25161ed594479910d8f8595a0de0b37fc Mon Sep 17 00:00:00 2001
From: HongFei <zhf.hongfei@gmail.com>
Date: Thu, 12 May 2022 20:07:12 +0800
Subject: [PATCH] fix: the scriptFunction type in encodePackage (#43)

---
 src/utils/tx.ts | 8 +++++++-
 1 file changed, 7 insertions(+), 1 deletion(-)

diff --git a/src/utils/tx.ts b/src/utils/tx.ts
index b64289e..384d53a 100644
--- a/src/utils/tx.ts
+++ b/src/utils/tx.ts
@@ -46,7 +46,13 @@ export function encodePackage(
   const modules = moduleCodes.map((m) => new starcoin_types.Module(arrayify(m)));
   let scriptFunction = null;
   if (!!initScriptFunction) {
-    scriptFunction = encodeScriptFunction(initScriptFunction.functionId, initScriptFunction.tyArgs, initScriptFunction.args);
+    const funcId = parseFunctionId(initScriptFunction.functionId);
+    scriptFunction = new starcoin_types.ScriptFunction(
+      new starcoin_types.ModuleId(addressToSCS(funcId.address), new starcoin_types.Identifier(funcId.module)),
+      new starcoin_types.Identifier(funcId.functionName),
+      initScriptFunction.tyArgs.map((t) => typeTagToSCS(t)),
+      initScriptFunction.args
+    );
   }
   const packageData = new starcoin_types.Package(
     addressToSCS(moduleAddress),
